#include <iostream>
using namespace std;

#define MAXSIZE 100

//Adjacency martix
int MartixNodeNum;                  //The node we have
bool Graphic[MAXSIZE][MAXSIZE];     //The martix
bool ReachMartix[MAXSIZE][MAXSIZE]; //The reach martix of the Graphic

//Get the adjacency martix of the graphic
void InitGraphic()
{
    cout << "The node we have: " << endl;
    cin >> MartixNodeNum;

    cout << "Please input the adjacency martix which side length is " << MartixNodeNum << " : " << endl;

    for (int i = 0; i < MartixNodeNum; i++)
    {
        for (int j = 0; j < MartixNodeNum; j++)
        {
            cin >> Graphic[i][j];

            //Diagonal always unit martix
            if (i == j)
            {
                Graphic[i][j] = true;
            }
        }
    }
}

//Reachable martix
void ReachableMartix()
{
    //Init the rachmartix
    for (int i = 0; i < MartixNodeNum; i++)
    {
        for (int j = 0; j < MartixNodeNum; j++)
        {
            if (i == j || Graphic[i][j])
            {
                ReachMartix[i][j] = true;
            }
            else
            {
                ReachMartix[i][j] = false;
            }
        }
    }

    //Get reachableMartix
    for (int k = 0; k < MartixNodeNum; k++)
    {
        for (int i = 0; i < MartixNodeNum; i++)
        {
            for (int j = 0; j < MartixNodeNum; j++)
            {
                ReachMartix[i][j] = ReachMartix[i][j] || (ReachMartix[i][k] && ReachMartix[k][j]);
            }
        }
    }
}

//Judge Conneted Graph
int ConnectTypeJudger()
{
    //Strong Connection = 0
    //One-way connection = 1
    //Both are not = -1
    int Type = 0;

    //Judge whether strong
    for (int i = 0; i < MartixNodeNum; i++)
    {
        for (int j = 0; j < MartixNodeNum; j++)
        {
            if (ReachMartix[i][j] == 0)
            {
                Type = 1;
            }
        }
    }

    //Strong
    if (Type == 0)
    {
        return 0;
    }

    //Judge whether one-way
    for (int i = 0; i < MartixNodeNum; i++)
    {
        for (int j = 0; j < MartixNodeNum; j++)
        {
            //Not one-way
            if (ReachMartix[i][j] == 0 && ReachMartix[i][j] == 0)
            {
                return -1;
            }
        }
    }

    //One-way
    return 1;
}

//Judge weak
bool ConnectWeakJudger()
{
    //Trans the diagraph to the underected graph
    for (int i = 0; i < MartixNodeNum; i++)
    {
        for (int j = 0; j < MartixNodeNum; j++)
        {
            //Not one-way
            if (Graphic[i][j])
            {
                Graphic[j][i] = true;
            }
        }
    }

    //Judge again
    ReachableMartix();
    if (ConnectTypeJudger() == 0)
    {
        return true;
    }
    return false;
}

//Display
void DisplayMartix(bool D[][MAXSIZE])
{
    for (int i = 0; i < MartixNodeNum; i++)
    {
        for (int j = 0; j < MartixNodeNum; j++)
        {
            cout << D[i][j] << '\t';
        }
        cout << endl;
    }
}

int main()
{
    InitGraphic();
    cout << "Graphic" << endl;
    DisplayMartix(Graphic);

    cout << endl;

    ReachableMartix();
    cout << "ReachableMartix" << endl;
    DisplayMartix(ReachMartix);

    cout << endl;

    switch (ConnectTypeJudger())
    {
    case 0:
        cout << "Strong";
        break;
    case 1:
        cout << "One-way";
        break;
    default:
        switch (ConnectWeakJudger())
        {
        case true:
            cout << "Weak";
            break;
        default:
            cout << "None";
            break;
        }
    }

    return 0;
}