#pragma once
//1.2合式公式
#include "PropositionalSymbolization.h" //1.1命题符号化

/**
 * 1、命题常元或者命题变元是合式公式
 * 2、合式公式的复合也是合式公式
 * 3、有限次使用1、2得到的符号串也是合式公式
 * 4、设A是合式公式C的一部分且A本身是合式公式，则称A是C的子公式，不同于自身的子公式称为真子公式
 * 5、子公式的概念应该包含它在原公式中出现的位置
 * 6、在命题逻辑中，代入是对命题变元而言，要求在将被取代的命题变元的所有出现的地方都进行取代，并且是同时进行的取代
 * 7、在命题逻辑中，替换则是针对某一子公式而言的，它只要求对该子公式的某一个出现或某几个出现进行替换，而不一定是对每一处出现都进行替换。
*/

//代入
Statement Substitute(Statement p)
{
}

//替换
Statement Replace()
{
}